import java.io.*;
import java.net.*;
import java.util.*;
import java.sql.*;

public class MsSettle
{
	private	String ust = "";
	private	String enc = "";
	private	StringTokenizer	prm;
	private	boolean	tflg = false;
	private	boolean	sflg = false, wflg = false;
	private	Bord3Array	mb = null;

	public final static String def_urlst = "http://quote.yahoo.co.jp/q";

	public MsSettle()
	{
		ust = def_urlst;
		enc = "EUC-JP";
	}

	public MsSettle(String st, String ec)
	{
		ust = st;
		enc = ec;
	}

	public String getcontent(String st)
	{
		String pt;
		StringBuffer	dt = new StringBuffer(96 * 1024);

//System.err.println(st);
		try {
			InputStream ct = new URL(st).openStream();
			BufferedReader in = new BufferedReader(new InputStreamReader(ct, enc));
			while ((pt = in.readLine()) != null)
				dt.append(pt);
		}
		catch (Exception e) {
			System.out.println("Exception: " + e.toString());
			dt.append("Exception: " + e.toString());
		}
		return dt.toString();
	}

	public String nextToken()
	{
		boolean	flg = tflg;
		String	tmp = "";

		while (prm.hasMoreTokens()) {
			String	wk = prm.nextToken();
			char	cin = wk.charAt(0);

			if (cin == '"')
				wflg = !wflg;
			if (!wflg && cin == '\'')
				sflg = !sflg;

			if (!sflg && cin == '<')
				tflg = true;
			else if (!sflg && cin == '>')
				tflg = false;

			if (tflg != flg)
				return tmp;
			tmp += wk;
		}
		return tmp;
	}

	private String replace(String tkn, String from, String to)
	{
		String wk = "";
		int rtn, idx = 0;

		if (to == null)
			to = "";

		while ((rtn = tkn.indexOf(from, idx)) >= 0) {
			wk += (tkn.substring(idx, rtn) + to);
			idx = rtn + from.length();
		}
		wk += tkn.substring(idx);
		return wk;
	}

	public class Bord3Array
	{
		public Vector	list = null;

		Bord3Array()
		{
			list = new Vector();
			list.clear();
		}

		public void additem(int tr, String val)
		{
			try {
				Vector	item = null;

				if (list.size() <= tr) {
					item = new Vector();
					item.clear();
					list.add(tr, item);
				}

				item = (Vector)list.get(tr);
				item.add(val);
				list.set(tr, item);
			}
			catch (ArrayIndexOutOfBoundsException e) {
				System.out.println("Exception: " + e.toString());
			}
		}

		public String toCsv(int md)
		{
			String	wk = "";
			for (int i = 0; i < list.size(); ++i) {
				Vector	item = (Vector)list.get(i);

				if (item.size() < 48)
					continue;

				if (wk.length() != 0)
					wk += "\n";
				for (int j = 0; j < item.size(); ++j) {
					String tmp = (String)item.get(j);
					tmp = yhreplace(md, j, tmp);
					if (tmp == null)
						continue;
					wk += "\"" + tmp + "\",";
				}
			}

			return wk;
		}

		public String toString()
		{
			String	wk = "";
			for (int i = 0; i < list.size(); ++i) {
				Vector	item = (Vector)list.get(i);

				for (int j = 0; j < item.size(); ++j) {
					String tmp = (String)item.get(j);
					wk += tmp + "|";
				}
				wk += "\n";
			}
			return wk;
		}

		public String yhreplace(int md, int n, String st)
		{
			String ttl = null;
			String tmp = null;

			switch (n) {
			case  2:	// 
				ttl = "\",Ծ,,," + st + ",\"";
					// ޥͥåڷ()
					//  (ޥ : 8626) 
					// 12/21  
					// 24,700
					// (ǽ)
				break;
			case  5:	// 
				ttl = st + "\",\"Ψ";
					// -100 (-0.40%)
				break;
			case  7:	// 
			case  9:	// 
			case 11:	// 
			case 13:	// 
			case 15:	// 
			case 17:	// 
			case 23:	// ȯԺѳ
				ttl = st;
				break;

			case 37:	// Ψ
				ttl = "Ϣñ\",\"" + st;
				break;

			case 25:	// 
			case 27:	// 1
			case 29:	// Ψ
			case 31:	// 1
			case 33:	// Ψ
			case 35:	// 1
			case 39:	// Ψ
			case 41:	// Ψ
			case 43:	// Ĵ1

			case 47:	// ñ
				ttl = st;
				break;

			case  0:	// ޥͥåڷ()
				tmp = st;
				break;
			case  1:	//  (ޥ : 8626) 
				tmp = st;
				tmp = replace(tmp, " ", "");
				tmp = replace(tmp, "(", "");
				tmp = replace(tmp, ")", "");
				tmp = replace(tmp, ":", "\",\"");
				break;
			case  3:	// 12/21  
				tmp = replace(st, " ", "");
				break;
			case  4:	// 24,700
				if (st.indexOf('(') < 0)
					tmp = st + "\",\"";
				else
					tmp = replace(st, "(ǽ)", "\",\"");
				break;
			case  6:	// -100 (-0.40%)
				tmp = st;
				tmp = replace(tmp, "(", "");
				tmp = replace(tmp, ")", "");
				tmp = replace(tmp.trim(), " ", "\",\"");
				break;
			case  8:	// 24,800
			case 10:	// 218
				tmp = st;
				break;
			case 12:	// 37,198ɴ
				tmp = replace(st, "ɴ", "");
				break;
			case 14:	// 24,750
			case 16:	// 24,750
			case 18:	// 24,300
				tmp = st;
				break;
			case 24:	// 1,505,977
				tmp = replace(st, "", "");
				break;

			case 38:	// (ñ) 88.2%
				tmp = st;
				tmp = replace(tmp, "(", "");
				tmp = replace(tmp, ")", "");
				tmp = replace(tmp.trim(), " ", "\",\"");
				if (st.indexOf(')') < 0)
					tmp = "\",\"" + tmp;
				break;

			case 26:	// ---%
			case 28:	// ---
			case 30:	// (ñ) -40.46
			case 32:	// (ñ) -610.46
			case 34:	// (ñ) 3.34
			case 36:	// (ñ) 7,405.53
			case 40:	// (ñ) -11.77%
			case 42:	// (ñ) -9.96%
			case 44:	// ---
				tmp = st;
				tmp = replace(tmp, "Ϣ", "");
				tmp = replace(tmp, "ñ", "");
				tmp = replace(tmp, "", "");
				tmp = replace(tmp, "", "");
				tmp = replace(tmp, "()", "");
				break;

			case 48:	// ---
				tmp = replace(st, "---", "1");
				tmp = replace(tmp, "", "");
				break;

			case 19:	// 㤤
			case 20:	// ---
			case 21:	// 굤
			case 22:	// ---
			case 45:	// ʬ丶
			case 46:	// ---ɴ
				break;
			}

			if (md == 0)
				return ttl;

			if (tmp != null) {
				tmp = replace(tmp, "---%", "");
				tmp = replace(tmp, "---", "");
			}
			return tmp;
		}
	}

	public int msget(String qry)
	{
		int tb3 = 0, tbl = 0, tr = 0, td = 0;
		int	tbk = 0, rec = 0;

		mb = null;
		mb = new Bord3Array();
		prm = new StringTokenizer(getcontent(ust + qry), "<>\"'", true);
		while (prm.hasMoreTokens()) {
			String tk = nextToken();

			if (tk.length() == 0)
				continue;

			if (tflg) {
//System.out.println("["+tb3+","+tbl+","+tr+","+td+"]"+tk);
				if (tb3 < 4)
					continue;
				if (tb3 >= 4 && tbl == 0)
					break;
				if (tb3 != tbk) {
					tbk = tb3;
					rec = 0;
				}
				if (tbk < 4)
					continue;
				if (tr == 1 && td == 1) {
					if (rec < 2) {
//System.out.println("["+tbk+","+rec+"]"+tk);
						mb.additem(tbk - 4, tk);
						++rec;
					}
				}
				else if (tr > 1) {
//System.out.println("["+tbk+","+rec+"]"+tk);
					mb.additem(tbk - 4, tk);
					++rec;
				}
			}
			else {
				String tmp = tk.toLowerCase();
				if (tmp.startsWith("table")) {
					tr = td = 0;
					if (++tbl == 1)
						++tb3;
				}
				else if (tmp.startsWith("/table")) {
					if (tbl > 0)
						--tbl;
				}
				else if (tmp.startsWith("tr")) {
					++tr;
				}
				else if (tmp.startsWith("/tr")) {
					td = 0;
				}
				else if (tmp.startsWith("td")) {
					++td;
				}
				else if (tmp.startsWith("/td")) {
				}
			}
		}

		System.err.println(qry);
		if (rec == 0) {
			System.err.println("error: " + qry);
			return 0;
		}

		return 1;
	}

	public int get(String code)
	{
		return msget("?d=nc&s=" + code);
	}

	public synchronized void putTitle()
	{
		if (mb == null)
			return;
		String tmp = mb.toCsv(0);
		System.out.println(tmp);
	}

	public synchronized void put()
	{
		if (mb == null)
			return;
		String tmp = mb.toCsv(1);
		System.out.println(tmp);
	}
}
