import java.io.*;
import java.net.*;
import java.util.*;
import java.text.*;

public class YhDy
{
	static final String enc = "EUC-JP";
	private final static DecimalFormat num_fmt = new DecimalFormat("#0000");
	private final static int thmax = 8;
	private final static int urlmax = 245;

	static public void main(String args[])
	{
		String pt, st;
		MsSettle mf = new MsSettle();

		switch (args.length) {
		case 1:
			break;
		default:
			System.err.println("YhDy ver0.01");
			System.err.println("Usage: YhDy file");
			System.err.println("  URL=" + mf.def_urlst);
			return;
		}
		st = args[0];

		YhDy lc = new YhDy();
		lc.lyfile(st);

		return;
	}

	public void lyfile(String st)
	{
		String pt, qry = "";
		MsThreadLoop mt[] = new MsThreadLoop[thmax];

		try {
			FileInputStream ct = new FileInputStream(st);
			BufferedReader in = new BufferedReader(new InputStreamReader(ct, enc));
			int cnt = 0;

			MsSettle mf = new MsSettle();
			mf.get("8627");
			mf.putTitle();

			while ((pt = in.readLine()) != null) {
//System.err.println(pt);
				if (pt.length() < 4 || pt.length() > 5)
					continue;

				int cd = 0;
				try {
					cd = Integer.valueOf(pt).intValue();
				}
				catch (Exception e) {
//System.err.println(pt + ": " + e);
					continue;
				}
				pt =  num_fmt.format(cd);
//System.err.println(pt + ": ok");
				if (qry.length() == 0)
					qry = pt;
				else
					qry += "+" + pt;
				if (qry.length() < urlmax)
					continue;

				try {
					mt[cnt] = new MsThreadLoop(qry);
					qry = "";
					mt[cnt].start();
					++cnt;
				}
				catch (Exception e) {
					System.err.println("ng: " + e.toString());
				}

				try {
					if (cnt >= thmax) {
						cnt = 0;
						for (int i = 0; i < thmax; ++i) {
							if (mt[i] != null) {
								mt[i].join();
								mt[i] = null;
							}
						}
					}
				}
				catch (Exception e) {
					System.err.println("ng: " + e.toString());
				}
			}

			if (qry.length() != 0) {
				try {
					mt[cnt] = new MsThreadLoop(qry);
					mt[cnt].start();
					++cnt;
				}
				catch (Exception e) {
					System.err.println("ng: " + e.toString());
				}
			}

			try {
				for (int i = 0; i < cnt; ++i) {
					if (mt[i] != null)
						mt[i].join();
				}
			}
			catch (Exception e) {
				System.err.println("ng: " + e.toString());
			}
		}
		catch (Exception e) {
			System.err.println("Exception: " + e.toString());
		}
	}

	public class MsThreadLoop extends Thread
	{
		public MsSettle mf = new MsSettle();
		public String pt = null;

		public MsThreadLoop(String p1)
		{
			pt = p1;
		}

		public void run()
		{
//System.err.println(this + ":" + pt);
			mf.get(pt);
			mf.put();
		}
	}
}
